/* -*- c-basic-offset: 2 -*- */

package nwnintf;
import java.io.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;
import nwnintf.format.mod.ModFile;
import nwnintf.format.mod.ResRef;

/**
 * Encapsulate a ScriptSlotRef and information about where it is stored.
 */

public interface SavedSlot {

  public ScriptSlotRef getSlotref();

  public void update(ModFile mod, SezFile sez,
		     ScriptCode scriptcode) throws Exception;

  /**
   * Have the SavedSlot undo its effects on whatever it is attached to,
   * remove any auxiliary resources it put into the module,
   * and remove its record in the SEZ ItpFile.
   * @return The ResRef that this slot is set to after the delete
   * operation completes. return val.type will be null. (-1 in integer form)
   */
  public ResRef delete(ModFile mod, SezFile sez) throws Exception;
}
