/* -*- c-basic-offset: 2 -*- */

package nwnintf;
import java.io.*;
import nwnintf.format.mod.ModFile;
import nwnintf.format.mod.ResRef;

/**
 * Encapsulate a blueprint with a script slot and the source code string
 * to go in it.
 */

public class ScriptSlot {

  ScriptSlotRef slotref_;

  ScriptCode code_;
  
  /**
   * Bytecode gets filled in later.
   */
  public ScriptSlot(ScriptSlotRef slotref, String sourcecode)
    throws Exception {
    slotref_ = slotref;
    code_ = new ScriptCode(sourcecode);
  }

  public ScriptSlotRef getSlotref() {
    return slotref_;
  }

  public String getSourcecode() {
    return code_.getSourcecode();
  }
  public void setBytecode(byte[] bytecode) {
    code_.setBytecode(bytecode);
  }
  public byte[] getBytecode() {
    return code_.getBytecode();
  }

  public ScriptCode getCode() {
    return code_;
  }
}
