/* -*- c-basic-offset: 2 -*- */

package nwnintf;
import java.io.*;
import java.util.*;
import nwnintf.format.*;
import nwnintf.format.mod.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;

/**
 * Represent the value given to a script slot, For use with 
 * SavedScripts and "updating all instances"
 */

public class SlotValue {
  ScriptSlotRef slotref_;
  ResRef value_;


  /**
   * @param slotref The slot the value of which was changed.
   * @param value May be null, indicating that the slot was cleared.
   */
  public SlotValue( ScriptSlotRef slotref, ResRef value ) {
    slotref_ = slotref;
    value_ = value;
  }

  public ScriptSlotRef getSlotRef() {
    return slotref_;
  }
  public ResRef getValue() {
    return value_;
  }

  public int hashCode() {
    return slotref_.hashCode() ^ value_.hashCode();
  }

  public boolean equals(Object obj) {
    if( obj instanceof SlotValue ) {
      SlotValue o = (SlotValue)obj;
      return slotref_.equals(o.slotref_) && value_.equals(o.value_);
    }
    return false;
  }

  public String toString() {
    return slotref_.toString() + "=" + value_;
  }
}
