/* -*- c-basic-offset: 2 -*- */
package nwnintf.conversation;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Draw conversation nodes in the correct color for their speaker/link type.
 */
public class ConversationCellRenderer extends DefaultTreeCellRenderer {

  public Component getTreeCellRendererComponent( JTree tree,
						 Object value,
						 boolean sel,
						 boolean expanded,
						 boolean leaf,
						 int row,
						 boolean hasFocus) {
    super.getTreeCellRendererComponent( tree,value,sel,expanded,
					leaf,row,hasFocus );
    DefaultMutableTreeNode node =
      (DefaultMutableTreeNode)value;
    ConversationNode cn = (ConversationNode)node.getUserObject();

    Color c;
    if( cn == null ) {
      // root node, no info.
      setText("Root");
      c = Color.black;
    } else if( cn.isChild() ) {
      c = Color.gray;
    } else if( cn.speaker() == ConversationTree.SPEAKER_PC ) {
      c = Color.blue;
    } else {
      // not child, speaker is NPC
      c = Color.red;
    }
    setForeground(c);
    return this;
  }
  
  
}
