/* -*- c-basic-offset: 2 -*- */
package nwnintf.conversation;

import javax.swing.tree.*;
import nwnintf.format.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;
import nwnintf.format.tlk.*;

/**
 * Provide the interface demanded by DefaultMutableTreeNode for userobjects.
 */
public class ConversationNode {
  
  ItpEntry entry_;
  String label_;
  int speaker_;
  boolean isChild_;
  boolean isTerminal_;


  ConversationNode( ItpEntry entry, String label, int speaker,
		    boolean isChild, boolean isTerminal ) {
    entry_ = entry;
    speaker_ = speaker;
    isChild_ = isChild;
    isTerminal_ = isTerminal;
    label_ = label;
  }

  ConversationNode( TlkFile tlk, ItpEntry entry, int speaker,
		    boolean isChild, boolean isTerminal ) 
    throws java.io.IOException {
    entry_ = entry;
    speaker_ = speaker;
    isChild_ = isChild;
    isTerminal_ = isTerminal;
    
    label_ = ((ItpStrrefElt)entry.element("Text")).defaultValue(tlk);

    if( label_ == null || label_.equals("") ) {
      // JTree gets retarded for a blank node.
      if( isTerminal ) {
	label_ = "[END DIALOGUE]";
      } else {
	label_ = "[CONTINUE]";
      }
    }
    if( speaker == ConversationTree.SPEAKER_NPC ) {
      label_ = "[OWNER] - " + label_;
    }
  }


  /**
   * toString() is the only thing DefaultMutableTreeNode needs.
   */
  public String toString() {
    return label_;
  }

  public ItpEntry entry() {
    return entry_;
  }

  public int speaker() {
    return speaker_;
  }

  public boolean isChild() {
    return isChild_;
  }
}
