/* -*- c-basic-offset: 2 -*- */

package nwnintf.example;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import java.io.*;
import java.util.*;

import nwnintf.*;
import nwnintf.format.*;
import nwnintf.format.mod.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;
import nwnintf.palette.*;
import nwnintf.conversation.*;

public class ConvListPanel extends JPanel {
  JList list_;

  public ConvListPanel( NwnModule module ) {

    list_ = new JList( makeVector(module) );
    list_.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );

    JScrollPane scrollPane = new JScrollPane(list_);
    this.add(scrollPane);

    GridBagLayout gridbag = new GridBagLayout();
    setLayout(gridbag);


    GridBagConstraints c = new GridBagConstraints();
    c.gridwidth = 1;
    c.gridheight = 1;
    c.gridx = 0;
    c.gridy = 0;
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1;
    c.weighty = 1;
    gridbag.setConstraints( scrollPane, c );
    add( scrollPane );


  }

  public void addConvSelectionListener(final ActionListener listener) {
    list_.addListSelectionListener(new ListSelectionListener() {
	public void valueChanged(ListSelectionEvent e) {
	  listener.actionPerformed( new ActionEvent(this, 0/*whatever*/,
						    "whatever") );
	}
      });
  }

  public ResRef getSelectedResRef() {
    return (ResRef)list_.getSelectedValue();
  }
  
  private static Vector makeVector(NwnModule module) {
    Vector conversations = new Vector();
    for( Iterator it = module.getModfile().iterator( ResRef.tiDLG ); it.hasNext(); ) {
      conversations.add( it.next() );
    }
    return conversations;
  }


}
