/* -*- c-basic-offset: 2 -*- */

package nwnintf.example;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.io.*;
import java.util.*;

import nwnintf.*;
import nwnintf.format.*;
import nwnintf.format.mod.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;
import nwnintf.palette.*;
import nwnintf.conversation.*;


public class ExampleFrame extends JFrame {

  NwnModule module_;
  File load_dir_;

  ExamplePanel expanel_;

  public ExampleFrame() {

    JPanel content = (JPanel) this.getContentPane();

    this.addWindowListener(
      new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
	  handleExit();
        }
      }
    );

    this.setTitle("nwnintf examples");
    this.setJMenuBar(this.createMenuBar());

    this.pack();

    handleLoadModule();
    //newModule( new File("matt test 1.mod") );

  }

  private JMenuBar createMenuBar() {
    JMenuBar bar;
    JMenu menu;
    JMenuItem item;

    bar = new JMenuBar();

    // File Menu

    menu = new JMenu("File");

    item = new JMenuItem("Load Module");
    item.addActionListener(
			   new ActionListener() {
			       public void actionPerformed(ActionEvent ev) {
				 handleLoadModule();
			       }
			     }
			   );
    menu.add(item);

    item = new JMenuItem("Exit");
    item.addActionListener(
			   new ActionListener() {
			       public void actionPerformed(ActionEvent ev) {
				 handleExit();
			       }
			     }
			   );
    menu.add(item);

    bar.add(menu);

    return bar;
  }

  private File chooseFile(String dialogTitle) {
    File load_dir;
    if( load_dir_ != null ) { load_dir = load_dir_; }
    else { load_dir = new File("."); }

    JFileChooser chooser = new JFileChooser(".");
    chooser.setDialogTitle(dialogTitle);
    int select = chooser.showOpenDialog(this);

    if( select == JFileChooser.APPROVE_OPTION ) {
      try {
	File file = chooser.getSelectedFile();
	load_dir_ = chooser.getCurrentDirectory();
	return file;
      } catch( Exception e ) {
	e.printStackTrace();
      }
    }
    return null;
  }

  private void handleLoadModule() {
    File f = chooseFile("Load Module");

    if( f != null ) {
      newModule(f);
    }
  }

  private void newModule(File f) {
    try {
      module_ = new NwnModule(f);

      JPanel content = (JPanel) this.getContentPane();
      if( expanel_ != null ) {
	content.remove( expanel_ );
      }
      expanel_ = new ExamplePanel(module_);
      content.add( expanel_ );
      content.validate();
      this.pack();

    } catch( Exception e ) {
      e.printStackTrace();
    }
  }

  private void handleExit() {
    System.exit(0);
  }
} 
