/* -*- c-basic-offset: 2 -*- */

package nwnintf.format.itp.element;

import nwnintf.format.*;
import nwnintf.format.itp.*;

public class ItpDatrefElt extends ItpElement {

  byte[] data_;

  public ItpDatrefElt( ItpFile f ) {
    super(f);
    data_ = new byte[0];
  }
  public void read( byte[] bytes, int eltoffset, int varnameoffset,
                    int vardataoffset, int listoffset ) {
    super.read( bytes, eltoffset, varnameoffset, vardataoffset, listoffset );

    int dataoffset = vardataoffset + Prim.int32lsb( bytes, eltoffset + DATA );
    int length = Prim.int32lsb( bytes, dataoffset );
    data_ = new byte[length];
    System.arraycopy( bytes, dataoffset + 4, data_, 0, length );
  }
  public int type() {
    return TYPE_DATREF;
  }

  public byte[] getData() {
    return data_;
  }
  public void setData(byte[] data) {
    data_ = data;
  }

  protected int childData(ItpWriter w) throws java.io.IOException {
    int data = w.vardata().size();
    w.vardata().writeInt(data_.length);
    w.vardata().writeBytes(data_);
    return data;
  }
}
