/* -*- c-basic-offset: 2 -*- */

package nwnintf.format.itp.element;

import java.io.IOException;
import nwnintf.format.*;
import nwnintf.format.itp.*;

public class ItpFloat64Elt extends ItpElement {

  double value_;

  public ItpFloat64Elt( ItpFile f ) {
    super(f);
  }
  public void read( byte[] bytes, int eltoffset, int varnameoffset,
                    int vardataoffset, int listoffset ) {
    super.read( bytes, eltoffset, varnameoffset, vardataoffset, listoffset );

    int dataoffset = vardataoffset + Prim.int32lsb( bytes, eltoffset + DATA );
    value_ = Double.longBitsToDouble(Prim.int64lsb( bytes, dataoffset ));
  }
  public int type() {
    return TYPE_FLOAT64;
  }
  protected int childData(ItpWriter w) throws IOException {
    int data = w.vardata().size();
    w.vardata().writeDouble(value_);
    return data;
  }
}
