/* -*- c-basic-offset: 2 -*- */

package nwnintf.format.itp.element;

import java.io.IOException;
import nwnintf.format.*;
import nwnintf.format.itp.*;

public class ItpInt64Elt extends ItpElement {

  private long value_;

  public ItpInt64Elt( ItpFile f ) {
    super(f);
  }
  public void read( byte[] bytes, int offset, int varnameoffset,
                    int vardataoffset, int listoffset ) {
    super.read( bytes, offset, varnameoffset, vardataoffset, listoffset );

    value_ = Prim.int64lsb( bytes, offset );
  }
  public int type() {
    return TYPE_INT64;
  }

  protected int childData(ItpWriter w) throws IOException {
    int data = w.vardata().size();
    w.vardata().writeLong(value_);
    return data;
  }

}
