/* -*- c-basic-offset: 2 -*- */

package nwnintf.format.itp.element;

import nwnintf.format.*;
import nwnintf.format.itp.*;

public class ItpResrefElt extends ItpElement {
  String value_;

  public ItpResrefElt( ItpFile f ) {
    super(f);
  }
  public void read( byte[] bytes, int eltoffset,
		    int varnameoffset, int vardataoffset,
                    int listoffset ) {
    super.read( bytes, eltoffset, varnameoffset, vardataoffset, listoffset );

    int nameoffset = vardataoffset + Prim.int32lsb( bytes, eltoffset + DATA );

    // First byte is count.
    int length = Prim.uint8( bytes, nameoffset );
    // Remaining bytes are contents.
    value_ = Prim.string0( bytes, nameoffset + 1, length );
    
  }
  public int type() {
    return TYPE_RESREF;
  }
  protected int childData(ItpWriter w) throws java.io.IOException {
    int data = w.vardata().size();
    w.vardata().writeByte( value_.length() );
    w.vardata().writeBytes( value_ );
    return data;
  }
  public String value() {
    return value_;
  }
  public void setValue(String val) {
    value_ = val;
  }

}
