/* -*- c-basic-offset: 2 -*- */

package nwnintf.format.itp.element;

import java.io.IOException;
import nwnintf.format.*;
import nwnintf.format.itp.*;

public class ItpStringElt extends ItpElement {
  String value_;

  public ItpStringElt( ItpFile f ) {
    super(f);
  }
  public void read( byte[] bytes, int eltoffset, int varnameoffset,
                    int vardataoffset, int listoffset ) {
    super.read( bytes, eltoffset, varnameoffset, vardataoffset, listoffset );

    int stroffset = vardataoffset + Prim.int32lsb( bytes, eltoffset + DATA );

    // First word is count.
    int length = Prim.int32lsb( bytes, stroffset );
    // Remaining bytes are contents.
    value_ = Prim.string( bytes, stroffset + 4, length );

  }
  public int type() {
    return TYPE_STRING;
  }
  protected int childData(ItpWriter w) throws IOException {
    int data = w.vardata().size();
    w.vardata().writeInt( value_.length() );
    w.vardata().writeBytes(value_);
    return data;
  }
  public String value() {
    return value_;
  }
  public void setValue(String value) {
    value_ = value;
  }
}
