/* -*- c-basic-offset: 2 -*- */
package nwnintf.palette;

import java.util.*;

import javax.swing.tree.*;
import nwnintf.format.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;
import nwnintf.format.mod.*;
import nwnintf.format.tlk.*;

/**
 * Cache SinglePaletteTrees for use by many instances of palette pickers.
 */
public class MultiPaletteTree  {

  Map typemap_;

  /**
   * Cache all the palettes in the module.
   */
  public MultiPaletteTree( ModFile mod, TlkFile tlk )
			  throws Exception
  {

    typemap_ = new HashMap();
    for( Iterator it = MultiPalette.paletteTypes();
	 it.hasNext(); ) {
      PaletteType pt = (PaletteType)(it.next());

      byte[] resdata = mod.resource( pt.resref() );
      ItpFile itp = new ItpFile( resdata );
      PaletteTree pal = new PaletteTree( itp, tlk,
					 ResRef.typeInt(pt.restype()) );

      typemap_.put( pt.restype(), pal );
    }
  }

  public PaletteTree treeByType( String type ) {
    return (PaletteTree) typemap_.get(type);
  }
  
  /**
   * Set of Map.Entry, key is restype eg. "utc" value is PaletteTree.
   */
  public Set entries() {
    return typemap_.entrySet();
  }
}

