/* -*- c-basic-offset: 2 -*- */
package nwnintf.palette;

import javax.swing.tree.*;
import nwnintf.format.*;
import nwnintf.format.mod.*;
import nwnintf.format.itp.*;
import nwnintf.format.itp.element.*;
import nwnintf.format.tlk.*;

/**
 * Provide the interface demanded by DefaultMutableTreeNode for userobjects.
 */
public class PaletteNode {
  
  ItpEntry entry_;
  String label_;
  int restype_;

  PaletteNode( ItpEntry entry, String label, int restype ) {
    entry_ = entry;
    label_ = label;
    restype_ = restype;
  }
  PaletteNode( ItpEntry entry, int restype ) {
    this( entry, ((ItpStringElt)entry.element("NAME")).value(), restype );
  }
  PaletteNode( String label, int restype ) {
    entry_ = null;
    label_ = label;
    restype_ = restype;
  }

  /**
   * toString() is the only thing DefaultMutableTreeNode needs.
   */
  public String toString() {
    return label_;
  }

  public ResRef resref() {
    if( entry_ != null )
      return new ResRef(((ItpResrefElt)entry_.element("RESREF")).value(),
			restype_);
    return null;
  }

  public ItpEntry entry() {
    return entry_;
  }
}
