/* -*- c-basic-offset: 2 -*- */
package nwnintf.palette;

import nwnintf.format.mod.ResRef;

/**
 * Describe a palette, e.g. creature palette, door palette, etc.
 */
class PaletteType {

  String iconpath_, label_, restype_;
  ResRef resref_;

  /**
   * @param resref The name of the palette resource in a module file
   * e.g. "creaturepalcus.itp".
   * @param iconpath A path to an icon file to represent this palette
   * from the app's main resource directory.
   * @param label A tooltip for the palette button.
   * @param restype The resource type that this palette points to
   * instances of, * e.g. "uti" for item palette.
   */
  public PaletteType( ResRef resref, String iconpath,
	       String label, String restype ) {
    resref_ = resref;
    iconpath_ = iconpath;
    label_ = label;
    restype_ = restype;
  }

  public ResRef resref() { return resref_; }
  public String iconpath() { return iconpath_; }
  public String label() { return label_; }
  public String restype() { return restype_; }
}
